enchant();



window.onload = function () {
	var game = new Game(400, 600);  				//画面サイズを400*500にする。（このサイズだとスマホでも快適なのでおススメ）

	//結果ツイート時にURLを貼るため、このゲームのURLをここに記入
	var url = "http://hothukurou.firebird.jp/game/Scenario/index.html";
	url = encodeURI(url); //きちんとURLがツイート画面に反映されるようにエンコードする
	/////////////////////////////////////////////////
	//ゲーム開始前に必要な画像・音を読み込む部分

	var IMG_NUMBER = 9;		//画像を読み込む数（定数（値がプログラム中に変化しない変数）は大文字で記述することにする）
	var B_IMG = new Array(IMG_NUMBER + 1);	//IMG_NUMBER+1の配列を用意する
	for (var i = 1; i <= IMG_NUMBER; i++) {
		B_IMG[i] = "image/image" + i + ".png";
		game.preload([B_IMG[i]]);
	}

	var SND_NUMBER = 4;		//音声データを読み込む数（定数（値がプログラム中に変化しない変数）は大文字で記述することにする）
	var B_SND = new Array(SND_NUMBER + 1);
	for (var i = 1; i <= SND_NUMBER; i++) {
		B_SND[i] = "sound/sound" + i + ".mp3";
		game.preload([B_SND[i]]);
	}

	//前半のノベルデータ
	var pushCommetNovel = [
		{ type: "text", text: "「押しちまった・・・！", img: "", snd: "", scene: "" },
		{ type: "text", text: "「メテオスイッチを押しちまったぞ・・・！", img: "", snd: "", scene: "" },
		{ type: "text", text: "・・・ディスプレイには、隕石の落下時間が表示されている。", img: "", snd: "", scene: "" },
		{ type: "text", text: "「押すなと言われたら押してしまうのが、人情・・・！", img: "", snd: "", scene: "" },
		{ type: "text", text: "「まあ、しゃあねえ。しりぬぐいするしかない・・・！", img: "", snd: "", scene: "" },
		{ type: "img", text: "", img: 6, snd: "", scene: "" },
		{ type: "text", text: "「この飛行機で、隕石に神風特攻するしかねえ・・・！", img: "", snd: "", scene: "" },
		{ type: "text", text: "「あばよ！地球！", img: "", snd: "", scene: "" },
		{ type: "text", text: "「俺は隕石を破壊して、英雄になる！", img: "", snd: "", scene: "" },
		{ type: "jump", text: "", img: "", snd: "", scene: "attack" }
	];

	//後半のノベルデータ
	var endingNovel = [
		{ type: "text", text: "こうして地球は救われた。", img: "", snd: "", scene: "" },
		{ type: "text", text: "彼の命と引き換えに、平和な日常がはじまるのだ。", img: "", snd: "", scene: "" },
		{ type: "text", text: "確かに彼は取り返しのつかないことをした。", img: "", snd: "", scene: "" },
		{ type: "text", text: "好奇心にまかせて、メテオスイッチを押してしまったのだ。", img: "", snd: "", scene: "" },
		{ type: "text", text: "しかし、誰が彼を責められようか。", img: "", snd: "", scene: "" },
		{ type: "text", text: "なぜなら好奇心は子供の特権だからだ。", img: "", snd: "", scene: "" },
		{ type: "text", text: "そして、取り返しのつかない罪を背負い、人は大人になるのだ。", img: "", snd: "", scene: "" },
		{ type: "text", text: "そう、彼は大人になったのだ。", img: "", snd: "", scene: "" },
		{ type: "text", text: "墓標の上の星が、彼の人生を祝福していた。", img: "", snd: "", scene: "" },
		{ type: "jump", text: "", img: "", snd: "", scene: "ending" }
	];

	//読み込み終わり
	/////////////////////////////////////////////////

	game.onload = function () {					//ロードが終わった後にこの関数が呼び出されるので、この関数内にゲームのプログラムを書こう

		//便利な関数群を定義
		//主にオブジェクト生成用の関数

		//ラベルオブジェクトを返す関数
		function setLabel(text) {
			//ポイント表示テキスト
			var label = new Label(); 					//テキストはLabelクラス
			label.font = "20px Meiryo";				//フォントはメイリオ 20px 変えたかったらググってくれ
			label.color = 'rgba(255,255,255,1)';		//色　RGB+透明度　今回は白
			label.width = 400;							//横幅指定　今回画面サイズ400pxなので、width:400pxだと折り返して二行目表示してくれる
			label.moveTo(0, 30);						//移動位置指定
			label.text = text;					//テキストに文字表示 Pointは変数なので、ここの数字が増える
			return label;						//作成したラベルを返す
		}

		//背景に引数の色を塗ったシーンを返す関数
		function setScene(color) {
			var scene = new Scene();					//シーン作成
			scene.backgroundColor = color; 			//S_MAINシーンの背景は黒くした
			return scene;
		}

		//テキスト裏にうす黒い背景をつける関数（引数で）
		function setTextBack(height) {					//テキスト裏に半透明の黒を貼るための関数
			var sprite = new Sprite(400, height);		//引数を縦の長さにして、
			sprite.backgroundColor = "black";			//このspriteを黒背景で塗りつぶす
			sprite.opacity = 0.5;						//透明度0.5で半透明にする
			return sprite;								//作成した半透明黒spriteを返す
		}

		//順に流れるコメントオブジェクトを返す関数　（内容結構複雑なので、流し見てください）
		function setCrawlingText() {
			//コメントクラス
			var CommentText = Class.create(Label, {	//(難し目の話)ちょっと前のjavascript(ES5)仕様ではclass定義ができないので、enchant.js独自のクラス定義を使用
				Cnt: 0,
				ComCnt: 0,
				NFlg: 1,
				Speed: 1,
				Comment: "",
				check: function () {//流れている最中はfalseを返す
					if (this.NFlg == 0) return false;
					else return true;
				},
				view: function View(text) {//文章表示命令　文章送り表示中なら次を表示せずに0を返す。1なら次の文章表示
					if (this.NFlg == 0) return false;
					this.Comment = text;
					if (this.NFlg == 1) this.NFlg = 0;
					this.Cnt = 0;
					return true;
				},
				clear: function Clear() {//表示文章を消去する
					this.text = "";
				},
				mode: function Mode(_Mode) {//_Mode決定 0:文章少しずつ表示　1:文章一度にすべて表示
					if (_Mode == 0) {
						this.NFlg = 0;
					} else {
						this.NFlg = 2;
					}
				},
				setSpeed: function SetSpeed(_Speed) {//１フレームで表示する文字数を引数の値に変更する
					this.Speed = _Speed;
				},
				initialize: function initialize() {//コンストラクタ　初めに呼び出される
					Label.call(this, "");			//ラベルクラスを継承する
					this.font = "20px Meiryo";		//labelクラスと同様にフォント定義
					this.color = "#ffffff";			//色定義
					this.width = 360;				//幅定義(画面外にはみ出さないよう折り返すため)
				},
				onenterframe: function onenterframe() {//毎フレーム毎に文字を表示する処理
					if (this.NFlg == 0) {
						this.text = ("" + this.Comment).substring(0, this.Cnt);
						this.Cnt += this.Speed;
						if (("" + this.Comment).length < this.Cnt - this.Speed + 1) {
							this.NFlg = 1;
							this.ComCnt++;
						}
					}
					if (this.NFlg == 2) {
						this.text = this.Comment;
						this.Cnt++;
					}
				}
			});
			return new CommentText();
		}


		/////////////////////////////////////////////////////////////////////////
		//最初のボタンをpushするシーン
		//
		var BUTTONPUSH = setScene("#ffffff");

		//ボタンプッシュシーンの初期化関数
		function goBUTTONPUSH() {							//何度もプレイするゲームだと、この手の初期化関数を用意すると便利
			game.popScene();								//現在のSceneを消去
			game.pushScene(BUTTONPUSH);					//BUTTONPUSHを表示
			BUTTONPUSH.state = 0;							//state=0にして状態を初期化
		}

		//そのシーンに固定で設置するSpriteは即時間数内で全部定義する
		// (function(){
		//	この中で変数を宣言すると、この中でのみ使用することができる。（後で同じ変数を宣言した時にごっちゃにならないので便利）
		// })
		//外部で使わない、一度宣言したら変更しない変数は即時間数内で定義
		(function () {
			var black = setTextBack(30);//高さ30pxの黒背景
			black.moveTo(0, 0);			//画面上部に置く
			BUTTONPUSH.addChild(black);//BUTTONPUSHに設置

			var text = setLabel("クリックでボタンを押せ！");//テキスト宣言
			text.moveTo(0, 5);							//移動
			BUTTONPUSH.addChild(text);				//BUTTONPUSHに設置
		}());


		//発射ボタン
		var button = new Sprite(60, 40);
		button.image = game.assets[B_IMG[3]];
		button.moveTo(170, 560);
		BUTTONPUSH.addChild(button);

		//手
		var hand = new Sprite(60, 100);
		hand.image = game.assets[B_IMG[4]];
		hand.moveTo(0, 30);
		BUTTONPUSH.addChild(hand);

		//手を動かす部分の毎フレーム処理
		BUTTONPUSH.onenterframe = function () {
			if (this.state == 0) {	//はじめはこれが呼ばれる。初期化処理
				this.time = 0;
				this.state = 1;
			} else if (this.state == 1) {	//手がSin波で左右に移動する
				hand.x = Math.sin(this.time / 10) * 160 + 180;
				hand.y = 30;
				this.time++;
			} else if (this.state == 2) {	//手が落ちていく
				hand.y += 10;
				if (hand.y >= 480) {		//手のY軸が一定以下で当たり判定処理
					if (hand.x > 170 && hand.x < 210) {	//もし手がスイッチを押していたらstate=3に移動　
						game.assets[B_SND[2]].clone().play();
						this.state = 3;
					} else {
						this.state = 9999;		//失敗時はstate=9999に移動
					}
				}
			} else if (this.state >= 3 && this.state <= 60) {//state=3になるとstateを時間計測として利用して1ずつ増やし、stateが60になったら次のシーンへ移動
				this.state++;
				if (this.state == 60) {
					goCommetNovel();							//COMMETNOVELへ移動
				}
			} else if (this.state == 9999) {				//外した時の処理
				hand.y += 10;								//手はとりあえず画面下まで移動する
				if (hand.y >= 650) {						//yが650以降なら
					goGameOver(1);							//ゲームオーバーシーンへ移動 引数１は現在の状況が１ということ。goGameOver関数を見ると引数で現在状況を理解している
				}
			}
		}


		BUTTONPUSH.ontouchend = function () {				//BUTTONPUSHの画面クリック処理
			if (this.state == 1) {							//手がSin波で動いている状態state=1ならstate=2へ遷移する
				this.state = 2;
				game.assets[B_SND[1]].clone().play();
			}
		}


		///////////////////////////////////////////////////////
		//ボタンを押した後のノベルシーン
		//

		//ボタン押した後のノベルシーンの初期化関数
		function goCommetNovel() {
			game.popScene();			//いつもの画面遷移
			game.pushScene(COMMETNOVEL);	//いつもの画面遷移
			COMMETNOVELBackImage.image = game.assets[B_IMG[5]];//最初に表示する画像に変更
			COMMETNOVELCrawlText.view(pushCommetNovel[0].text);//最初に表示するテキストに変更
			COMMETNOVEL.state = 1;			//ノベルパートのstateはコメント配列のインデックスをして利用。index１のコメントから表示するため、state=1にする
		}


		var COMMETNOVEL = setScene("#000000");				//COMMETNOVEL　Sceneを定義
		var COMMETNOVELBackImage = new Sprite(400, 600);		//背景画像用のSpriteを定義
		COMMETNOVEL.addChild(COMMETNOVELBackImage);				//COMMETNOVEL Sceneに背景Spriteを貼付
		(function () {										//またまた即時間数を定義
			var back = setTextBack(100);					//画面下に半透明黒を設置（即時間数内だとbackみたいな適当な変数名でも他と被らず便利！）
			back.moveTo(0, 500);							//画面下に設置
			COMMETNOVEL.addChild(back);						//Sceneに貼付
		}());

		var COMMETNOVELCrawlText = setCrawlingText("white");	//ノベル用のテキストSpriteを定義。引数は文字の色
		COMMETNOVELCrawlText.moveTo(0, 500);					//画面下に設置
		COMMETNOVEL.addChild(COMMETNOVELCrawlText);				//Sceneに貼付


		COMMETNOVEL.ontouchend = function () {				//COMMETNOVEL　Sceneのクリックイベント
			if (COMMETNOVELCrawlText.check()) {				//ノベルの文章が全部表示されていればtrueを返すので中の処理を行う
				game.assets[B_SND[4]].clone().play();
				var nextNovel = pushCommetNovel[this.state];							//stateの値を使って次に表示するノベルデータを読み込む
				while (nextNovel.type != "text") {										//そのノベルデータのtypeがtextでなければ、画像変更・音表示・画面遷移かである。
					if (nextNovel.type == "img") {										//imgなら画像を変更
						COMMETNOVELBackImage.image = game.assets[B_IMG[nextNovel.img]];	//nextNovel.imgに画像番号を入れたので、その番号の画像に背景を変更
					} else if (nextNovel.type == "snd") {								//sndなら音を鳴らす
						//ここにSEを鳴らす処理を加える（今回は使っていない）
					} else if (nextNovel.type == "jump") {								//jumpなら画面遷移で別シーンに移動する
						if (nextNovel.scene == "attack") {								//sceneにattackが入っているなら
							goAttackMoon();											//ATTACKMOONに画面遷移する
							return;
						}
					}
					this.state++;														//typeがtext以外ならstateを１足して
					nextNovel = pushCommetNovel[this.state];							//nextNovelに次のノベルデータを読み込む
				}
				COMMETNOVELCrawlText.view(pushCommetNovel[this.state].text);				//ノベルデータのtextの文字列をview関数の引数にする
				this.state++;

			}
		}

		/////////////////////////////////////////////////////////////////
		//隕石に特攻するゲームシーン
		//

		//隕石の特攻するゲームシーンの初期化関数
		function goAttackMoon() {
			game.popScene();
			game.pushScene(ATTACKMOON);
			ATTACKMOON.state = 0;				//stateを初期化
			ATTACKMOON.time = 0;				//timeを初期化
			plane.moveTo(10, 500);				//飛行機の位置を初期化
			comet.moveTo(300, 30);				//隕石の位置を初期化（今回隕石は動かさなかったのでここで初期化する必要もなかった・・・。）
		}

		var ATTACKMOON = setScene("#000080");			//ATTACKMOONを定義

		//そのシーンに固定で設置するSpriteは即時間数内で全部定義する
		(function () {
			var black = setTextBack(30);//テキスト裏の黒半透明を高さ30pxで作成
			black.moveTo(0, 0);
			ATTACKMOON.addChild(black);

			var text = setLabel("クリックで飛行機を隕石に当てろ！");		//テキスト表示
			text.moveTo(0, 5);
			ATTACKMOON.addChild(text);
		}());

		var comet = new Sprite(100, 100);							//隕石
		comet.image = game.assets[B_IMG[8]];						//隕石の画像をSpriteに入れる
		ATTACKMOON.addChild(comet);								//ATTACKMOONに貼付
		var plane = new Sprite(60, 60);								//飛行機
		plane.image = game.assets[B_IMG[7]];						//飛行機の画像をSpriteに入れる
		ATTACKMOON.addChild(plane);								//ATTACKMOONに貼付

		ATTACKMOON.onenterframe = function () {					//毎フレーム処理
			if (this.state == 0) {									//飛行機の向きが動いているシーン
				this.time++;
				plane.rotation = Math.sin(this.time / 10) * 45 - 45;	//反復動作はとりあえずsinを使う。planeのrotationは度数入力が必要なので0~90が代入されるようにしている。
			}
			if (this.state == 1) {									//飛行機が移動するシーン
				plane.x += plane.vx;								//vx,vyは角度から計算した移動量。これを毎フレーム足していく
				plane.y += plane.vy;								//

				var planeCenter = { x: plane.x + 30, y: plane.y + 30 };		//飛行機の中心座標
				var cometCenter = { x: comet.x + 50, y: comet.y + 50 };		//隕石の中心座標
				var vector = {												//飛行機の座標ー隕石の座標で二点間のベクトル定義
					x: planeCenter.x - cometCenter.x,
					y: planeCenter.y - cometCenter.y
				};
				var dist = Math.sqrt(vector.x * vector.x + vector.y * vector.y);	//ベクトルから二点間の距離を計算
				if (dist < 60) {													//二点間が60px未満なら当たったことにする
					game.assets[B_SND[3]].clone().play();
					goEnding();														//ENDING　sceneに移動
				}
				if (plane.x > 420 || plane.y < -100) {								//飛行機が画面外に出たらgameover
					this.state = 9999;												//stateを9999にする。 state=9999はゲームオーバー処理を書く
				}
			} else if (this.state == 9999) {										//ゲームオーバー遷移
				goGameOver(2);														//2のパターンでgameOverに移動　
			}
		}
		ATTACKMOON.ontouchend = function () {										//クリック時処理
			if (this.state == 0) {													//state=0の時だけ処理する
				var planeRad = plane.rotation * Math.PI * 2 / 360;					//飛行機の角度計算 度数をrad表記に変更するため(PI*2/360)を乗算している
				plane.vx = Math.cos(planeRad) * 10;									//計算した角度[rad]からx方向移動量vxを決定
				plane.vy = Math.sin(planeRad) * 10;									//計算した角度[rad]からy方向移動量vyを決定
				this.state = 1;														//stateを１にして移動開始
				game.assets[B_SND[1]].clone().play();
			}
		}

		//////////////////////////////////////////////////////////////////////////////////
		//エンディングノベル
		//

		//エンディングノベルの初期化関数
		function goEnding() {
			game.popScene();														//今のsceneを外す
			game.pushScene(ENDING);													//ENDING sceneを表示
			endBackImage.image = game.assets[B_IMG[9]];
			endCrawlText.view(endingNovel[0].text);									//ノベルテキストをindex:0にする
			ENDING.state = 1;														//stateをノベルindexにするため、1にする
		}

		var ENDING = setScene("#000000");											//ENDING scene を定義

		var endBackImage = new Sprite(400, 600);									//ENDINGノベルの背景を定義
		ENDING.addChild(endBackImage);												//背景画像をSceneに追加
		(function () {																//そのシーンに固定で設置するSpriteは即時間数内で全部定義する
			var back = setTextBack(100);											//テキストバックの黒半透明を高さ100pxで設置
			back.moveTo(0, 500);
			ENDING.addChild(back);
		}());

		var endCrawlText = setCrawlingText("white");								//ノベル用テキストSpriteを定義(引数は文字の色)
		endCrawlText.moveTo(0, 500);												//座標指定
		ENDING.addChild(endCrawlText);												//ENDINGに設置


		ENDING.ontouchend = function () {											//クリック時の処理
			if (endCrawlText.check()) {												//ノベルの文章が全部表示されていればtrueを返すので中の処理を行う
				game.assets[B_SND[4]].clone().play();								//stateの値を使って次に表示するノベルデータを読み込む
				var nextNovel = endingNovel[this.state];							//nextNovelに次のノベルデータを代入(stateをindexにする)
				while (nextNovel.type != "text") {									//そのノベルデータのtypeがtextでなければ、画像変更・音表示・画面遷移かである。
					if (nextNovel.type == "img") {									//imgなら画像を変更
						endBackImage.image = game.assets[B_IMG[nextNovel.img]];		//nextNovel.imgに画像番号を入れたので、その番号の画像に背景を変更
					} else if (nextNovel.type == "snd") {							//sndなら音を鳴らす
						//ここにSEを鳴らす処理を加える（今回は素材がないので不可）
					} else if (nextNovel.type == "jump") {							//jumpなら画面遷移で別シーンに移動する
						if (nextNovel.scene == "ending") {							//sceneにendingが入っているなら
							goGameOver(3);											//GAMEOVER sceneに画面遷移する(3:クリア)
							return;
						}
					}
					this.state++;
					nextNovel = endingNovel[this.state];
				}
				if (endCrawlText.view(endingNovel[this.state].text)) {
					this.state++;
				}
			}
		}

		////////////////////////////////////////////////////////////////////////
		// 結果シーン
		//

		//ゲームオーバーシーンの初期化関数
		function goGameOver(state) {			//stateの値によってどのシーンから飛んできたかを判定する
			game.popScene();					//シーンを外す
			game.pushScene(GAMEOVER);				//S_ENDシーンを読み込ませる
			//ゲームオーバー後のテキスト表示
			if (state == 1) gameOverText.text = "ボタンを押せずに突き指した。";				//テキストに文字表示 
			if (state == 2) gameOverText.text = "隕石が落ちて滅亡した。";				//テキストに文字表示 
			if (state == 3) gameOverText.text = "隕石を破壊して平和を守った！";				//テキストに文字表示 
		}


		var GAMEOVER = setScene("blue");							//END　Sceneを定義
		//GAMEOVER
		var gameOverText = setLabel("");
		gameOverText.moveTo(0, 30);						//移動位置指定
		GAMEOVER.addChild(gameOverText);						//S_ENDシーンにこの画像を埋め込む
		(function () {
			//リトライボタン
			var retry = new Sprite(120, 60);				//画像サイズをここに書く。使う予定の画像サイズはプロパティで見ておくこと
			retry.moveTo(50, 300);						//リトライボタンの位置
			retry.image = game.assets[B_IMG[2]];			//読み込む画像の相対パスを指定。　事前にgame.preloadしてないと呼び出せない
			GAMEOVER.addChild(retry);					//S_ENDにこのリトライボタン画像を貼り付ける  

			retry.ontouchend = function () {				//S_Retryボタンをタッチした（タッチして離した）時にこの中の内容を実行する
				goBUTTONPUSH();
				game.assets[B_SND[4]].clone().play();
			};

			//ツイートボタン
			var tweet = new Sprite(120, 60);				//画像サイズをここに書く。使う予定の画像サイズはプロパティで見ておくこと
			tweet.moveTo(230, 300);						//リトライボタンの位置
			tweet.image = game.assets[B_IMG[1]];			//読み込む画像の相対パスを指定。　事前にgame.preloadしてないと呼び出せない
			GAMEOVER.addChild(tweet);					//S_ENDにこのリトライボタン画像を貼り付ける  

			tweet.ontouchend = function () {				//S_Tweetボタンをタッチした（タッチして離した）時にこの中の内容を実行する
				//ツイートＡＰＩに送信
				window.open("http://twitter.com/intent/tweet?text=" + gameOverText.text + "&hashtags=ahoge&url=" + url); //ハッシュタグにahogeタグ付くようにした。
				game.assets[B_SND[4]].clone().play();
			};
		}());

		goBUTTONPUSH();

	};
	game.start();
};